// GITVERSION: vg.2-54-gbc96f24a
#ifndef EVAL_HPP
#define EVAL_HPP
#include "aedtools/evalbase.hpp"
#include <forward_list>
#include <sstream>
#include <algorithm>
using namespace std;

namespace aed {

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  //   FUNCTIONS FOR THIS EXAM
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  // END FUNCTIONS FOR THIS EXAM
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*> SIGN_SPLIT
#undef EJERC
#undef EVAL
#define EJERC 1
#define EVAL eval1_t
  typedef bool (*contained_t)(vector<int> &v1,vector<int> &v2);
  class EVAL : public eval_base_t {
  public:
    contained_t F;
    EVAL() { dumptests=0; F=NULL; ejerc=EJERC; testfile="./cnt.json"; }
    void run_case(json &data,json &outuser) {
      vector<int> v1 = data["v1"];
      vector<int> v2 = data["v2"];
      outuser["retval"] = F(v1,v2);
    }
    
    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
    
    void generate_case(randomg_t &rnd,json &datain) {
      vector<int> v1,v2;
      int n1,n2;
      if (rnd.rand()%2) { n1=12, n2=3; }
      else { n1=3, n2=12; }
      for (int j=0; j<n1; j++) v1.push_back(rnd.rand()%5);
      for (int j=0; j<n2; j++) v2.push_back(rnd.rand()%5);
      datain["v1"] = v1;
      datain["v2"] = v2;
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
#undef EJERC
#undef EVAL
#define EJERC 2
#define EVAL eval2_t
  typedef bool (*findsum_t)(vector<int> &v,int sumtarget);
  class EVAL : public eval_base_t {
  public:
    findsum_t F;
    EVAL() { dumptests=0; F=NULL; ejerc=EJERC; testfile="./fs.json"; }
    void run_case(json &data,json &outuser) {
      vector<int> v = data["v"];
      int sumtarget = data["sumtarget"];
      outuser["retval"] = F(v,sumtarget);
    }
    
    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
    
    void generate_case(randomg_t &rnd,json &datain) {
      vector<int> v,w;
      unsigned int n = 4+rnd.rand()%4;
      set<int> s;
      while (s.size()<n) s.insert(rnd.rand()%10);
      for (auto q : s) v.push_back(q);
      random_shuffle(rnd,v);
      w = v;
      random_shuffle(rnd,w);
      int sumt = 0;
#define CUBE(j) (j)*(j)*(j)
      for (int j=0; j<3; j++) sumt += CUBE(w[j]);
      if (rnd.rand()%2) sumt += rnd.rand()%20;
      datain["v"] = v;
      datain["sumtarget"] = sumt;
    }
  };


  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
#undef EJERC
#undef EVAL
#define EJERC 3
#define EVAL eval3_t
  typedef bool (*findperm_t)(vector<string> vs,string target);
  class EVAL : public eval_base_t {
  public:
    findperm_t F;
    EVAL() { dumptests=0; F=NULL; ejerc=EJERC; testfile="./fp.json"; }
    void run_case(json &data,json &outuser) {
      vector<string> vs;
      json vsj = data["vs"];
      for (auto &q : vsj) 
        vs.push_back(q.get<std::string>());
      string target=data["target"];
      outuser["retval"] = F(vs,target);
    }
    
    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
    
    void generate_case(randomg_t &rnd,json &datain) {
      vector<string> w,
        vs0 = {"a","bra","ca","da","bra"},
        vs1 = {"mbu","ru","cu","ya"},
        vs2 = {"mo","na","ste","rio"};
      int z = rnd.rand()%3;
      vector<string> &vs = (z==0? vs0 : z==1? vs1 : vs2);
      int n = 2+rnd.rand()%(vs.size()-2);
      w = vs;
      random_shuffle(rnd,w);
      string target = "";
      for (int j=0; j<n; j++) target += w[j];
      // Do random perturbation so as to make it fail
      if (rnd.rand()%4==0) target += string("boom");
      if (rnd.rand()%4==0) target += w[0];
      datain["vs"] = vs;
      datain["target"] = target;
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  using Eval = eval_t<eval1_t,contained_t,
                      eval2_t,findsum_t,
                      eval3_t,findperm_t>;
}

#undef CSTR
#define sort SORT_NO_DISPONIBLE

#endif
